<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

add_action( 'media_buttons', 								array('NNRobots_Quotables_Admin', 'add_shortcode_button'), 15);
add_action( 'wp_enqueue_media', 							array('NNRobots_Quotables_Admin', 'include_shortcode_button_scripts'));
add_action( 'wp_ajax_nnr_q_shortcode_default', 				array('NNRobots_Quotables_Admin', 'shortcode_default'));

class NNRobots_Quotables_Admin {

	/**
	 * Add shortcode button to WP Editor
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function add_shortcode_button() {

		// Get default shortcode settings

		$shortcode_default = get_option(NNRobots_Quotables::$prefix . 'shortcode_default');

		if ( $shortcode_default === false ) {
			$shortcode_default = array(
				'text'			=> 'Share this Article!',
				'platform'		=> 'twitter',
				'layout'		=> 'box',
				'style'			=> 'color',
				'bitly'			=> '',
				'button_text'	=> 'Share',
			);
		}

		echo '<button class="button ' . NNRobots_Quotables::$prefix_dash . 'shortcode-builder"><span class="wp-media-buttons-icon"></span>Quotables</button>
			<div class="' . NNRobots_Quotables::$prefix_dash . 'shortcode-builder-container">
			<div class="postbox ' . NNRobots_Quotables::$prefix_dash . 'shortcode-builder-box" style="display:none;">
			<h3>
				<span style="top: 6px;position: relative;">' . __('Quotables Builder', NNRobots_Quotables::$text_domain) . '</span>

				<button style="float: right;margin-right: 0px;" class="button ' . NNRobots_Quotables::$prefix_dash . 'shortcode-builder-close">' . __('Close', NNRobots_Quotables::$text_domain) . '</button>
				<button style="float: right;margin-right: 12px;" class="button button-primary ' . NNRobots_Quotables::$prefix_dash . 'shortcode-builder-add">' . __('Insert', NNRobots_Quotables::$text_domain) . '</button>
				<a style="float: right;margin-right: 12px;padding-top: 8px;" class="' . NNRobots_Quotables::$prefix_dash . 'shortcode-builder-default">' . __('Save as Default', NNRobots_Quotables::$text_domain) . '</a>
			</h3>
			<div class="inside">

				<p style="display:none;">
					<code class="' . NNRobots_Quotables::$prefix_dash . 'shortcode"></code>
				</p>

				<p style="text-align:center;">
					<label class="' . NNRobots_Quotables::$prefix_dash . 'platform-label">
						<input type="radio" name="' . NNRobots_Quotables::$prefix_dash . 'platform" class="' . NNRobots_Quotables::$prefix_dash . 'platform ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" value="twitter" ' . (isset($shortcode_default['platform']) && $shortcode_default['platform'] == 'twitter' ? 'checked="checked"' : '') . ' data-shortcode="platform"/>
						<img src="' . NNROBOTS_QUOTABLES_PLUGIN_URL . '/img/twitter-icon.png"/>
					</label>

					<label class="' . NNRobots_Quotables::$prefix_dash . 'platform-label">
						<input type="radio" name="' . NNRobots_Quotables::$prefix_dash . 'platform" class="' . NNRobots_Quotables::$prefix_dash . 'platform ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" value="facebook" ' . (isset($shortcode_default['platform']) && $shortcode_default['platform'] == 'facebook' ? 'checked="checked"' : '') . ' data-shortcode="platform"/>
						<img src="' . NNROBOTS_QUOTABLES_PLUGIN_URL . '/img/facebook-icon.png"/>
					</label>

					<label class="' . NNRobots_Quotables::$prefix_dash . 'platform-label">
						<input type="radio" name="' . NNRobots_Quotables::$prefix_dash . 'platform" class="' . NNRobots_Quotables::$prefix_dash . 'platform ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" value="google" ' . (isset($shortcode_default['platform']) && $shortcode_default['platform'] == 'google' ? 'checked="checked"' : '') . ' data-shortcode="platform"/>
						<img src="' . NNROBOTS_QUOTABLES_PLUGIN_URL . '/img/google-icon.png"/>
					</label>

					<label class="' . NNRobots_Quotables::$prefix_dash . 'platform-label">
						<input type="radio" name="' . NNRobots_Quotables::$prefix_dash . 'platform" class="' . NNRobots_Quotables::$prefix_dash . 'platform ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" value="pinterest" ' . (isset($shortcode_default['platform']) && $shortcode_default['platform'] == 'pinterest' ? 'checked="checked"' : '') . ' data-shortcode="platform"/>
						<img src="' . NNROBOTS_QUOTABLES_PLUGIN_URL . '/img/pinterest-icon.png"/>
					</label>

					<label class="' . NNRobots_Quotables::$prefix_dash . 'platform-label">
						<input type="radio" name="' . NNRobots_Quotables::$prefix_dash . 'platform" class="' . NNRobots_Quotables::$prefix_dash . 'platform ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" value="tumblr" ' . (isset($shortcode_default['platform']) && $shortcode_default['platform'] == 'tumblr' ? 'checked="checked"' : '') . ' data-shortcode="platform"/>
						<img src="' . NNROBOTS_QUOTABLES_PLUGIN_URL . '/img/tumblr-icon.png"/>
					</label>

					<label class="' . NNRobots_Quotables::$prefix_dash . 'platform-label">
						<input type="radio" name="' . NNRobots_Quotables::$prefix_dash . 'platform" class="' . NNRobots_Quotables::$prefix_dash . 'platform ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" value="linkedin" ' . (isset($shortcode_default['platform']) && $shortcode_default['platform'] == 'linkedin' ? 'checked="checked"' : '') . ' data-shortcode="platform"/>
						<img src="' . NNROBOTS_QUOTABLES_PLUGIN_URL . '/img/linkedin-icon.png"/>
					</label>

				</p>

				<p style="clear: both;padding-top: 20px;">
					<label for="' . NNRobots_Quotables::$prefix_dash . 'text">' . __('Text:', NNRobots_Quotables::$text_domain ) . '</label>
					<input class="widefat ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" id="' . NNRobots_Quotables::$prefix_dash . 'text" name="' . NNRobots_Quotables::$prefix_dash . 'text" type="text" value="' . $shortcode_default['text'] . '" data-shortcode="text"><br/>
					<em>' . __('The text you want to be shared', NNRobots_Quotables::$text_domain ) . '</em>
				</p>

				<p>
					<label for="' . NNRobots_Quotables::$prefix_dash . 'layout">' . __('Layout:', NNRobots_Quotables::$text_domain ) . '</label>
					<select id="' . NNRobots_Quotables::$prefix_dash . 'layout" name="' . NNRobots_Quotables::$prefix_dash . 'layout" class="' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" data-shortcode="layout">
						<option value="box" ' . selected('box', $shortcode_default['layout'], false) . '>' . __('Box', NNRobots_Quotables::$text_domain ) . '</option>
						<option value="bubble" ' . selected('bubble', $shortcode_default['layout'], false) . '>' . __('Bubble', NNRobots_Quotables::$text_domain ) . '</option>
					</select><br/>
					<em>' . __('The layout of the quotables card.', NNRobots_Quotables::$text_domain ) . '</em>
				</p>

				<p>
					<label for="' . NNRobots_Quotables::$prefix_dash . 'style">' . __('Style:', NNRobots_Quotables::$text_domain ) . '</label>
					<select id="' . NNRobots_Quotables::$prefix_dash . 'style" name="' . NNRobots_Quotables::$prefix_dash . 'style" class="' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" data-shortcode="style">
						<option value="color" ' . selected('color', $shortcode_default['style'], false) . '>' . __('Color', NNRobots_Quotables::$text_domain ) . '</option>
						<option value="light" ' . selected('light', $shortcode_default['style'], false) . '>' . __('Light', NNRobots_Quotables::$text_domain ) . '</option>
						<option value="dark" ' . selected('dark', $shortcode_default['style'], false) . '>' . __('Dark', NNRobots_Quotables::$text_domain ) . '</option>
					</select><br/>
					<em>' . __('The style of the quotables card.', NNRobots_Quotables::$text_domain ) . '</em>
				</p>

				<p>
					<label for="' . NNRobots_Quotables::$prefix_dash . 'bitly">' . __('Bitly Access Token:', NNRobots_Quotables::$text_domain ) . '</label>
					<input class="widefat ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" id="' . NNRobots_Quotables::$prefix_dash . 'bitly" name="' . NNRobots_Quotables::$prefix_dash . 'bitly" type="text" value="' . $shortcode_default['bitly'] . '" data-shortcode="bitly"><br/>
					<em>' . __("Insert your Bitly", NNRobots_Quotables::$text_domain) . ' <a href="https://bitly.com/a/oauth_apps" target="_blank"> ' . __('access token', NNRobots_Quotables::$text_domain) . '</a> ' . __("here. This is optional and will shorten post links if value is not blank. Pinterest will not accept", NNRobots_Quotables::$text_domain) . ' <a href="https://help.pinterest.com/en/articles/blocked-links-and-websites" target="_blank">' . __('shortened links', NNRobots_Quotables::$text_domain) . '</a> ' . __("so leave this setting blank for Pinterest.", NNRobots_Quotables::$text_domain) . '</em>
				</p>

				<p>
					<label for="' . NNRobots_Quotables::$prefix_dash . 'button_text">' . __('Button Text:', NNRobots_Quotables::$text_domain ) . '</label>
					<input class="widefat ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" id="' . NNRobots_Quotables::$prefix_dash . 'button-text" name="' . NNRobots_Quotables::$prefix_dash . 'button-text" type="text" value="' . $shortcode_default['button_text'] . '" data-shortcode="button_text"><br/>
					<em>' . __('The text of the share button.', NNRobots_Quotables::$text_domain ) . '</em>
				</p>

				<p class="' . NNRobots_Quotables::$prefix_dash . 'platform ' . NNRobots_Quotables::$prefix_dash . 'platform-twitter">
					<label for="' . NNRobots_Quotables::$prefix_dash . 'twitter_username">' . __('Twitter Username:', NNRobots_Quotables::$text_domain ) . '</label>
					<input class="widefat ' . NNRobots_Quotables::$prefix_dash . 'shortcode-input" id="' . NNRobots_Quotables::$prefix_dash . 'twitter-username" name="' . NNRobots_Quotables::$prefix_dash . 'twitter-username" type="text" value="' . $shortcode_default['twitter_username'] . '" data-shortcode="twitter_username"><br/>
					<em>' . __( 'Attribute the source of a Tweet to a Twitter username using the', NNRobots_Quotables::$text_domain ) . ' <a href="https://dev.twitter.com/web/tweet-button#component-via" target="_blank">' . __( 'via', NNRobots_Quotables::$text_domain ) . '</a> ' . __( 'parameter.  This would be your twitter username as a site owner without a @ (i.e. 99robots).', NNRobots_Quotables::$text_domain ) . '</em>
				</p>
			</div>
			</div>
		</div>';
	}

	/**
	 * Include all required files for making the Shortcode Builder work
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function include_shortcode_button_scripts() {

		// Scripts

		wp_enqueue_script(NNRobots_Quotables::$prefix . 'shortcode_builder_js', plugins_url('js/shortcode-builder.js', __FILE__), array('jquery', 'wp-color-picker'), false, true);
		// Styles

		wp_enqueue_style(NNRobots_Quotables::$prefix . 'shortcode_builder_css', plugins_url('css/shortcode-builder.css', __FILE__));

		// Localize Scripts

		wp_localize_script(NNRobots_Quotables::$prefix . 'shortcode_builder_js', 'nnr_q_shortcode', array(
			'prefix' 	=> NNRobots_Quotables::$prefix_dash,
			'ajaxurl'	=> admin_url( 'admin-ajax.php' ),
			'admin_url'	=> get_admin_url(),
		));

	}

	/**
	 * Saves the shortcode default settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function shortcode_default() {

		// Get current setting

		$shortcode_default = get_option(NNRobots_Quotables::$prefix . 'shortcode_default');

		// Get all settings

		$shortcode_default = array(
			'text'				=> $_POST['text'],
			'platform'			=> $_POST['platform'],
			'layout'			=> $_POST['layout'],
			'style'				=> $_POST['style'],
			'bitly'				=> $_POST['bitly'],
			'button_text'		=> $_POST['button_text'],
			'twitter_username'	=> $_POST['twitter_username'],
		);

		// Save defaults

    	$result = update_option(NNRobots_Quotables::$prefix . 'shortcode_default', $shortcode_default);

    	echo $result;
    	die();
	}

}